/**
* File handles json data returned from IMG Ad server
* dynamically included
**/
var json_resp = '';
var sh_countCPC = 5;
var sh_countCPA = 1;
var totalAdCount = 0;

function openWindow(url)
{ 
     var newWin = window.open(url,'_blank','','false'); 
}

/**
* callback function handling data returned from ad server.
* 
*/
function jsonStrFromAdserver(s,adType) {
  var resultCount = 0;
    // Process response from Ad Server.
  if (typeof( s ) != "undefined" && s != '') {
    var json_results = eval(s);
    resultCount = json_results.count;
    if (resultCount != 0) {
       drawHeading();
      if (adType == "CPC") { 
        sh_countCPC = resultCount;
      } else if (adType == "CPA") {
        sh_countCPA = resultCount;
      }
    }
    
    if (adType == "CPC") {
      displayCPCAds(json_results, sh_countCPA, sh_pg);
    } else if (adType == "CPA") {
      displayCPAAds(json_results, sh_countCPC, sh_pg);
    }
    //drawSeperator();
   // drawHeading();
  }
}

function addEvent(obj, evType, fn, useCapture){
  if (obj.addEventListener){
    obj.addEventListener(evType, fn, useCapture);
    return true;
  } else if (obj.attachEvent){
    var r = obj.attachEvent("on"+evType, fn);
    return r;
  } else {
    alert("Handler could not be attached");
  }
}

function IDtoObject(inID)
{
  return document.getElementById(inID);
}


//addEvent(window,'load', requestCPAAds,false);
addEvent(window,'load', requestCPCAds,false);

//The following dynamic node insertion functions can be refactored later to avoid duplication
/**
* Function to dynamically insert the javascript node on load to avoid cross domain browser request issues while requesting CPC ads.
*/
function requestCPCAds() {

request = cpc_requrl+'/ads/json_feed_fast2.php?p_id='+cpc_p_id+'&ad_count='+cpc_ad_count+'&uip='+cpc_uip+'&channel='+cpc_channel+'&limit='+cpc_limit+'&doc_offset='+cpc_doc_offset+'&keyword='+cpc_keyword+'&region='+cpc_region+'&adType=CPC&referring_page='+referring_page+'';
aObj = new JSONscriptRequest(request);
aObj.buildScriptTag();
aObj.addScriptTag();
}

/**
* Function to dynamically insert the javascript node on load to avoid cross domain browser request issues while requesting CPA ads.
*/


function requestCPAAds() {

request = cpa_requrl+'/ads/json_feed_fast2.php?p_id='+cpa_p_id+'&ad_count='+cpa_ad_count+'&uip='+cpa_uip+'&channel='+cpa_channel+'&limit='+cpa_limit+'&doc_offset='+cpa_doc_offset+'&keyword='+cpa_keyword+'&region='+cpa_region+'&adType=CPA';

aObj = new JSONscriptRequest(request);
aObj.buildScriptTag();
aObj.addScriptTag();
}

function openWindow(url)
{
	var newWin = window.open(url,'_blank','','false');
}

function handleAdClick(inEvent)
{
  if (!inEvent) inEvent = window.event;
  
  var adDiv = inEvent.target;
  if (!adDiv) adDiv = inEvent.srcElement;
  
  if (adDiv)
  {
    if (!adDiv.id)
    {
      adDiv = adDiv.parentNode;
    }
    var adAnchor = document.getElementById(adDiv.id + "_anchor");
    if (adAnchor)
    {    
      openWindow(adAnchor.href);
    }
  }
  
}

function displayCPCAds(json_results_cpc, countCPA, pg) {
  var slotDiv = document.getElementById('inclick_cpc_ads');
  
  if (slotDiv == null) { s
    slotDiv = document.createElement("div");
    slotDiv.id = "shspimgcpc";
    document.body.appendChild(slotDiv);
  }
  totalAdCount = json_results_cpc.count;
  for (var i=0;i < json_results_cpc.count; i++) {

    adSlotDiv = document.createElement("div");
    adSlotDiv.className = "inclick_ads";
    adSlotDiv.onclick = handleAdClick;    
    adSlotDiv.id = "inclick_ad" + i;
    
    adsTextBold = document.createElement("b");
    adsTextBold = document.createElement("div");    
    adsTextBold.className = "inclick_ads_headline";
    adsClickUrl = document.createElement("a");
    adsClickUrl.className = "ad_headline";
    adsClickUrl.href = json_results_cpc.listing[i].uri;
    adsClickUrl.innerHTML = json_results_cpc.listing[i].heading;
    adsClickUrl.target = "_blank";
    adsTextBold.appendChild(adsClickUrl);
    adSlotDiv.appendChild(adsTextBold);
    
    //adsDescription = document.createElement("p");
    adsDescription = document.createElement("div");
    adsDescription.className = "inclick_ads_body";
    adsDescriptionText = json_results_cpc.listing[i].description;
    adsDescription.innerHTML = adsDescriptionText;
    adSlotDiv.appendChild(adsDescription);
    
    adsDisplayUrl = document.createElement("div");
    adsDisplayUrl .className = "inclick_ads_displayurl";
    adsDisplayUrl = document.createElement("a");
    adsDisplayUrl.className = "ad_click_url";
    adsDisplayUrl.href = json_results_cpc.listing[i].uri;
    adsDisplayUrl.id = adSlotDiv.id + "_anchor";
    adsDisplayUrl.innerHTML = json_results_cpc.listing[i].url;
    adsDisplayUrl.target = "_blank";
    adSlotDiv.appendChild(adsDisplayUrl);
   
    slotDiv.appendChild(adSlotDiv);
    if (pg == 'sr') {
      adjustAdsHeight();
    }
   
  }
}
function drawSeperator() {
  if ((sh_countCPC != 0) || (sh_countCPA != 0)) {
    var slotDiv = document.getElementById('shspimgcpa');
    adSeperator = document.createElement("hr");
    //adSeperator.className = "hr";
    slotDiv. appendChild(adSeperator);
  }
}
function drawHeading() {
  var slotDiv = document.getElementById('inclick_cpc_ads');
  h4Element = slotDiv.getElementsByTagName('h4');
  h4Element[0].innerHTML= "<a class=\"network_block\" target=\"_blank\" href=\"" + ad_network_destination_link + "\">" + ad_network_name + "</a>";
}

function displayCPAAds(json_results_cpa, countCPC, pg) {
  var slotDiv = document.getElementById('shspimgcpa');
  totalAdCount = 0;
  for (var i=0;i < json_results_cpa.count; i++) {
    //totalAdCount++;
    adSlotDiv = document.createElement("div");
    adSlotDiv.className = "slot";
    adsTextBold = document.createElement("b");
    adsClickUrl = document.createElement("a");
    adsClickUrl.href = json_results_cpa.listing[i].uri;
    adsClickUrl.innerHTML = json_results_cpa.listing[i].heading;
    adsClickUrl.target = "_blank";
    //adsClickUrl.class = "ad_headline";
    adsTextBold.appendChild(adsClickUrl);
    adSlotDiv.appendChild(adsTextBold);
    adsDescription = document.createElement("p");
    adsDescriptionText = json_results_cpa.listing[i].description;
    adsDescriptionTextNode = document.createTextNode(adsDescriptionText);
    adsDescription.appendChild(adsDescriptionTextNode);
    adSlotDiv.appendChild(adsDescription);
    adsDisplayUrl = document.createElement("a");
    adsDisplayUrl.href = json_results_cpa.listing[i].uri;
    adsDisplayUrl.innerHTML = json_results_cpa.listing[i].url;
    adsDisplayUrl.target = "_blank";
    adSlotDiv.appendChild(adsDisplayUrl);
    slotDiv.appendChild(adSlotDiv);
    if (pg == 'sr') {
      adjustAdsHeight();
    }
  }
}

function adjustAdsHeight() {
  var imgads = IDtoObject('shsp');

  //var results = IDtoObject('searchresults');
  //var imgadsRect = environment.getNodeRectangle(imgads);
  //var resRect = environment.getNodeRectangle(results);
  //if (imgadsRect.height > resRect.height) results.style.height = imgadsRect.height+20 + 'px';
}

function JSONscriptRequest(fullUrl) {
  // REST request path
  this.fullUrl = fullUrl;
  // Keep IE from caching requests
  this.noCacheIE = "&noCacheIE=" + (new Date()).getTime();
  // Get the DOM location to put the script tag
  this.headLoc = document.getElementsByTagName("head").item(0);
  // Generate a unique script tag id
  this.scriptId = "YJscriptId" + JSONscriptRequest.scriptCounter++;
}

// Static script ID counter
JSONscriptRequest.scriptCounter = 1;

// buildScriptTag method
JSONscriptRequest.prototype.buildScriptTag = function () {
  // Create the script tag
  this.scriptObj = document.createElement("script");

  // Add script object attributes
  this.scriptObj.setAttribute("type", "text/javascript");
  this.scriptObj.setAttribute("src", this.fullUrl + this.noCacheIE);
  this.scriptObj.setAttribute("id", this.scriptId);
}

// removeScriptTag method
JSONscriptRequest.prototype.removeScriptTag = function () {
  // Destroy the script tag
  this.headLoc.removeChild(this.scriptObj);
}

// addScriptTag method
JSONscriptRequest.prototype.addScriptTag = function () {
  // Create the script tag
  this.headLoc.appendChild(this.scriptObj);
}