	var __codeToExecuteOnColorChange = false;
	
	var perline = 33;
     var divSet = false;
     var curId;
     var colorLevels = Array('0','0','0','1','2','3','4','5','6','7','8', '9','A','B','C','D','E','F');
    //var colorLevels = Array('0','1','2', '3',  '9', 'C', 'F');
     var colorArray = Array();
     var ie = false;
     var nocolor = 'none';
	 if (document.all) { ie = true; nocolor = ''; }
	 function getObj(id) {
		if (ie) { return document.all[id]; } 
		else {	return document.getElementById(id);	}
	 }

     function addColor(r, g, b) {
     	var red = colorLevels[r];
     	var green = colorLevels[g];
     	var blue = colorLevels[b];
     	addColorValue(red, green, blue);
     }

     function addColorValue(r, g, b) {
     	colorArray[colorArray.length] = '#' + r + r + g + g + b + b;
     }
     
     function setColor(color) {
     	var link = getObj(curId);
     	var field = getObj(curId + 'field');
     	var picker = getObj('colorpicker');
     	field.value = color;
     	if (color == '') {
	     	link.style.background = nocolor;
	     	link.style.color = nocolor;
	     	color = nocolor;
     	} else {
	     	link.style.background = color;
	     	link.style.color = color;
	    }
     	picker.style.display = 'none';

      if (__codeToExecuteOnColorChange != '')
      {
    		eval(__codeToExecuteOnColorChange);
    		__codeToExecuteOnColorChange = '';
      }
     }
        
     function setDiv() {     
     	if (!document.createElement) { return; }
        var elemDiv = document.createElement('div');
        if (typeof(elemDiv.innerHTML) != 'string') { return; }
        genColors();
        elemDiv.id = 'colorpicker';
	    elemDiv.style.position = 'absolute';
        elemDiv.style.display = 'none';
        elemDiv.style.border = '#000000 1px solid';
        elemDiv.style.background = '#FFFFFF';
        /*
        elemDiv.innerHTML = '<span style="font-family:Verdana; font-size:11px;">Pick a color: ' 
          	+ '(<a href="javascript:setColor(\'\');">No color</a>)<br>' 
        	+ getColorTable() 
        	+ '<center><a href="http://www.flooble.com/scripts/colorpicker.php"'
        	+ ' target="_blank">color picker</a> by <a href="http://www.flooble.com" target="_blank"><b>flooble</b></a></center></span>';
		*/
        elemDiv.innerHTML =  getColorTable();

        document.body.appendChild(elemDiv);
        divSet = true;
     }
     
     function pickColor(id, codeToExecute) {
     	if (!divSet) { setDiv(); }
     	var picker = getObj('colorpicker');     	
		if (id == curId && picker.style.display == 'block') {
			picker.style.display = 'none';
			return;
		}
     	curId = id;
     	var thelink = getObj(id);
     	picker.style.top = getAbsoluteOffsetTop(thelink) + 20;
     	picker.style.left = getAbsoluteOffsetLeft(thelink);     
	    picker.style.display = 'block';
	    
	    if (codeToExecute != '')
	    {
			__codeToExecuteOnColorChange = codeToExecute;
	    }
	    else
	    {
			__codeToExecuteOnColorChange = '';
		}
     }
     
     function genColors() {
        addColorValue('0','0','0');
        addColorValue('1','1','1');
        addColorValue('2','2','2');
        addColorValue('3','3','3');
        addColorValue('4','4','4');
        addColorValue('5','5','5');
        addColorValue('6','6','6');
        addColorValue('7','7','7');
        addColorValue('8','8','8');
        addColorValue('9','9','9');                
        addColorValue('A','A','A');                
        addColorValue('B','B','B');
        addColorValue('C','C','C');
        addColorValue('D','D','D');
        addColorValue('E','E','E');
        addColorValue('F','F','F');                                
			
        for (a = 1; a < colorLevels.length; a++)
			addColor(0,0,a);
        for (a = 1; a < colorLevels.length - 1; a++)
			addColor(a,a,9);

        for (a = 1; a < colorLevels.length; a++)
			addColor(0,a,0);
        for (a = 1; a < colorLevels.length - 1; a++)
			addColor(a,9,a);
			
        for (a = 1; a < colorLevels.length; a++)
			addColor(a,0,0);
        for (a = 1; a < colorLevels.length - 1; a++)
			addColor(9,a,a);
			
			
        for (a = 1; a < colorLevels.length; a++)
			addColor(a,a,0);
        for (a = 1; a < colorLevels.length - 1; a++)
			addColor(9,9,a);
			
        for (a = 1; a < colorLevels.length; a++)
			addColor(0,a,a);
        for (a = 1; a < colorLevels.length - 1; a++)
			addColor(a,9,9);

        for (a = 1; a < colorLevels.length; a++)
			addColor(a,0,a);			
        for (a = 1; a < colorLevels.length - 1; a++)
			addColor(9,a,9);
			
       	return colorArray;
     }
     function getColorTable() {
         var colors = colorArray;
      	 var tableCode = '';
         tableCode += '<table border="0" cellspacing="0" cellpadding="0">';
         for (i = 0; i < colors.length; i++) {
              if (i % perline == 0) { tableCode += '<tr>'; }
              tableCode += '<td bgcolor="#000000"><a style="outline: 0px solid #000000; color: ' 
              	  + colors[i] + '; background: ' + colors[i] + ';font-size: 10px;" title="' 
              	  + colors[i] + '" href="javascript:setColor(\'' + colors[i] + '\');">&nbsp;&nbsp;&nbsp;</a></td>';
              if (i % perline == perline - 1) { tableCode += '</tr>'; }
         }
         if (i % perline != 0) { tableCode += '</tr>'; }
         tableCode += '</table>';
      	 return tableCode;
     }
     function relateColor(id, color) {
     	var link = getObj(id);
      color = getColor(color);
      
      link.style.background = color;
      link.style.color = color;
     }
     
     function setBackgroundColor(id, color)
     {
       var item = getObj(id);
       color = getColor(color);
       
       item.style.background=color;       
     }
     
     function setForegroundColor(id, color)
     {
      var item = getObj(id);
      color = getColor(color);
      
      item.style.color = color;
     }
     
     function setBorderColor(id, color)
     {
      var item = getObj(id);
      color = getColor(color);
      
      item.style.borderColor = color;
     }
     
     function getColor(inColor)
     {
      if (inColor == '')
      {
        return nocolor;
      }
      if (inColor.charAt(0) != "#")
      {
        inColor = "#" + inColor;
      }
      return inColor;
     }
     
     function getAbsoluteOffsetTop(obj) {
     	var top = obj.offsetTop;
     	var parent = obj.offsetParent;
     	while (parent != document.body) {
     		top += parent.offsetTop;
     		parent = parent.offsetParent;
     	}
     	return top;
     }
     
     function getAbsoluteOffsetLeft(obj) {
     	var left = obj.offsetLeft;
     	var parent = obj.offsetParent;
     	while (parent != document.body) {
     		left += parent.offsetLeft;
     		parent = parent.offsetParent;
     	}
     	return left;
     }